<template>
  <v-dialog v-model="dialog" max-width="500">
    <v-card>
      <v-card-title class="headline">Update Product</v-card-title>

      <v-card-text>
        <v-form v-model="valid">
          <v-list>
            <v-text-field label="Name" v-model="name"/>
            <v-currency-field label="Current Price" v-bind="currency_config" v-model="price"/>
          </v-list>
        </v-form>
      </v-card-text>

      <v-card-actions>
        <v-spacer></v-spacer>

        <v-btn color="red darken-1" flat="flat" @click="dialog = false" :loading="loading">Cancel</v-btn>
        <v-btn
          color="green darken-1"
          flat="flat"
          @click="updateProduct(); dialog = false"
          :loading="loading"
        >Agree</v-btn>
      </v-card-actions>
    </v-card>
  </v-dialog>
</template>

<script>
import gql from "graphql-tag";

export default {
  props: {
    id: String
  },
  data() {
    return {
      product: null,
      valid: null,
      dialog: false,
      loading: false,
      currency_config: {
        decimal: ",",
        thousands: ".",
        prefix: "R$ ",
        precision: 2,
        masked: false,
        allowBlank: false,
        min: Number.MIN_SAFE_INTEGER,
        max: Number.MAX_SAFE_INTEGER
      },
      updates: {}
    };
  },
  computed: {
    name: {
      get() {
        return this.updates.name || (this.product && this.product.name);
      },
      set(v) {
        this.updates.name = v;
      }
    },
    price: {
      get() {
        return (
          (this.updates.price || (this.product && this.product.price)) / 100
        );
      },
      set(v) {
        this.updates.price = v * 100;
      }
    }
  },
  apollo: {
    product: {
      query: gql`
        query($id: ID!) {
          product(id: $id) {
            id
            name
            price
          }
        }
      `,
      skip() {
        return !this.id;
      },
      variables() {
        return { id: this.id };
      }
    }
  },
  methods: {
    open() {
      this.dialog = true;
    },
    async updateProduct() {
      this.loading = true;

      try {
        await this.$apollo.mutate({
          mutation: gql`
            mutation($id: ID!, $product: ProductInputUpdate!) {
              productUpdate(id: $id, product: $product) {
                id
              }
            }
          `,
          variables: {
            id: this.id,
            product: this.updates
          }
        });
      } catch (e) {
        console.error(e);
      } finally {
        this.loading = false;
      }
    }
  }
};
</script>
